Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/dtatsd.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/dtatsd.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/dtatsd.F90	(revision 14200)
@@ -142,4 +142,5 @@
       INTEGER ::   ik, il0, il1, ii0, ii1, ij0, ij1   ! local integers
       INTEGER ::   itile
+      INTEGER, DIMENSION(jpts), SAVE :: irec_b, irec_n
       REAL(wp)::   zl, zi                             ! local scalars
       REAL(wp), DIMENSION(jpk) ::  ztp, zsp   ! 1D workspace
@@ -157,19 +158,33 @@
          IF( cn_cfg == "orca" .OR. cn_cfg == "ORCA" ) THEN
             IF( nn_cfg == 2 .AND. ln_tsd_dmp ) THEN    ! some hand made alterations
+               irec_n(jp_tem) = sf_tsd(jp_tem)%nrec(2,sf_tsd(jp_tem)%naa)            ! Determine if there is new data (ln_tint = F)
+               irec_n(jp_sal) = sf_tsd(jp_sal)%nrec(2,sf_tsd(jp_sal)%naa)            ! If not, then do not apply the increments
+               IF( kt == nit000 ) irec_b(:) = -1
                !
                ij0 = 101 + nn_hls       ;   ij1 = 109 + nn_hls                       ! Reduced T & S in the Alboran Sea
                ii0 = 141 + nn_hls - 1   ;   ii1 = 155 + nn_hls - 1
-               DO jj = mj0(ij0), mj1(ij1)
-                  DO ji = mi0(ii0), mi1(ii1)
-                     sf_tsd(jp_tem)%fnow(ji,jj,13:13) = sf_tsd(jp_tem)%fnow(ji,jj,13:13) - 0.20_wp
-                     sf_tsd(jp_tem)%fnow(ji,jj,14:15) = sf_tsd(jp_tem)%fnow(ji,jj,14:15) - 0.35_wp
-                     sf_tsd(jp_tem)%fnow(ji,jj,16:25) = sf_tsd(jp_tem)%fnow(ji,jj,16:25) - 0.40_wp
-                     !
-                     sf_tsd(jp_sal)%fnow(ji,jj,13:13) = sf_tsd(jp_sal)%fnow(ji,jj,13:13) - 0.15_wp
-                     sf_tsd(jp_sal)%fnow(ji,jj,14:15) = sf_tsd(jp_sal)%fnow(ji,jj,14:15) - 0.25_wp
-                     sf_tsd(jp_sal)%fnow(ji,jj,16:17) = sf_tsd(jp_sal)%fnow(ji,jj,16:17) - 0.30_wp
-                     sf_tsd(jp_sal)%fnow(ji,jj,18:25) = sf_tsd(jp_sal)%fnow(ji,jj,18:25) - 0.35_wp
+               IF( sf_tsd(jp_tem)%ln_tint .OR. irec_n(jp_tem) /= irec_b(jp_tem) ) THEN
+                  DO jj = mj0(ij0), mj1(ij1)
+                     DO ji = mi0(ii0), mi1(ii1)
+                        sf_tsd(jp_tem)%fnow(ji,jj,13:13) = sf_tsd(jp_tem)%fnow(ji,jj,13:13) - 0.20_wp
+                        sf_tsd(jp_tem)%fnow(ji,jj,14:15) = sf_tsd(jp_tem)%fnow(ji,jj,14:15) - 0.35_wp
+                        sf_tsd(jp_tem)%fnow(ji,jj,16:25) = sf_tsd(jp_tem)%fnow(ji,jj,16:25) - 0.40_wp
+                     END DO
                   END DO
-               END DO
+                  irec_b(jp_tem) = irec_n(jp_tem)
+               ENDIF
+               !
+               IF( sf_tsd(jp_sal)%ln_tint .OR. irec_n(jp_sal) /= irec_b(jp_sal) ) THEN
+                  DO jj = mj0(ij0), mj1(ij1)
+                     DO ji = mi0(ii0), mi1(ii1)
+                        sf_tsd(jp_sal)%fnow(ji,jj,13:13) = sf_tsd(jp_sal)%fnow(ji,jj,13:13) - 0.15_wp
+                        sf_tsd(jp_sal)%fnow(ji,jj,14:15) = sf_tsd(jp_sal)%fnow(ji,jj,14:15) - 0.25_wp
+                        sf_tsd(jp_sal)%fnow(ji,jj,16:17) = sf_tsd(jp_sal)%fnow(ji,jj,16:17) - 0.30_wp
+                        sf_tsd(jp_sal)%fnow(ji,jj,18:25) = sf_tsd(jp_sal)%fnow(ji,jj,18:25) - 0.35_wp
+                     END DO
+                  END DO
+                  irec_b(jp_sal) = irec_n(jp_sal)
+               ENDIF
+               !
                ij0 =  87 + nn_hls       ;   ij1 =  96 + nn_hls                       ! Reduced temperature in Red Sea
                ii0 = 148 + nn_hls - 1   ;   ii1 = 160 + nn_hls - 1
@@ -197,5 +212,4 @@
          ENDIF
          !
-         ! NOTE: [tiling-comms-merge] This fix was necessary to take out tra_adv lbc_lnk statements in the zps case, but did not work in the zco case
          DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )                  ! vertical interpolation of T & S
             DO jk = 1, jpk                        ! determines the intepolated T-S profiles at each (i,j) points
@@ -233,5 +247,4 @@
          !
          IF( ln_zps ) THEN                      ! zps-coordinate (partial steps) interpolation at the last ocean level
-            ! NOTE: [tiling-comms-merge] This fix was necessary to take out tra_adv lbc_lnk statements in the zps case
             DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
                ik = mbkt(ji,jj)
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/istate.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/istate.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/istate.F90	(revision 14200)
@@ -90,5 +90,5 @@
 
 #if defined key_agrif
-      IF ( (.NOT.Agrif_root()).AND.ln_init_chfrpar ) THEN
+      IF ( .NOT.Agrif_root() .AND. ln_init_chfrpar ) THEN
          numror = 0                           ! define numror = 0 -> no restart file to read
          ln_1st_euler = .true.                ! Set time-step indicator at nit000 (euler forward)
@@ -97,8 +97,4 @@
          !
          ts (:,:,:,:,Kmm) = ts (:,:,:,:,Kbb)
-!!st
-!!st need for a recent agrif version to be displaced toward ssh_init_rst with agrif_istate_ssh
-         ssh(:,:,    Kmm) = ssh(:,:    ,Kbb)
-!!st end
          uu (:,:,:  ,Kmm) = uu (:,:,:  ,Kbb)
          vv (:,:,:  ,Kmm) = vv (:,:,:  ,Kbb)
@@ -116,22 +112,10 @@
             CALL day_init                        ! model calendar (using both namelist and restart infos)
             !                                    ! Initialization of ocean to zero
+            !
             IF( ln_tsd_init ) THEN               
                CALL dta_tsd( nit000, ts(:,:,:,:,Kbb) )       ! read 3D T and S data at nit000
                !
-               ssh(:,:,Kbb)   = 0._wp               ! set the ocean at rest
-               uu  (:,:,:,Kbb) = 0._wp
+               uu  (:,:,:,Kbb) = 0._wp               ! set the ocean at rest
                vv  (:,:,:,Kbb) = 0._wp  
-               !
-               IF( ll_wd ) THEN
-                  ssh(:,:,Kbb) =  -ssh_ref  ! Added in 30 here for bathy that adds 30 as Iterative test CEOD 
-                  !
-                  ! Apply minimum wetdepth criterion
-                  !
-                  DO_2D( 1, 1, 1, 1 )
-                     IF( ht_0(ji,jj) + ssh(ji,jj,Kbb)  < rn_wdmin1 ) THEN
-                        ssh(ji,jj,Kbb) = tmask(ji,jj,1)*( rn_wdmin1 - (ht_0(ji,jj)) )
-                     ENDIF
-                  END_2D
-               ENDIF 
                !
             ELSE                                 ! user defined initial T and S
@@ -142,7 +126,6 @@
             ENDIF
             ts  (:,:,:,:,Kmm) = ts (:,:,:,:,Kbb)       ! set now values from to before ones
-            ssh (:,:,Kmm)     = ssh(:,:,Kbb)   
-            uu   (:,:,:,Kmm)   = uu  (:,:,:,Kbb)
-            vv   (:,:,:,Kmm)   = vv  (:,:,:,Kbb)
+            uu    (:,:,:,Kmm) = uu   (:,:,:,Kbb)
+            vv    (:,:,:,Kmm) = vv   (:,:,:,Kbb)
 
          !
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynatf.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynatf.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynatf.F90	(revision 14200)
@@ -60,11 +60,13 @@
    PUBLIC    dyn_atf   ! routine called by step.F90
 
-#if defined key_qco
+#if defined key_qco   ||   defined key_linssh
    !!----------------------------------------------------------------------
-   !!   'key_qco'      EMPTY ROUTINE     Quasi-Eulerian vertical coordonate
+   !!   'key_qco'                        Quasi-Eulerian vertical coordinate
+   !!       OR         EMPTY MODULE
+   !!   'key_linssh'                        Fix in time vertical coordinate
    !!----------------------------------------------------------------------
 CONTAINS
 
-   SUBROUTINE dyn_atf ( kt, Kbb, Kmm, Kaa, puu, pvv, pe3t, pe3u, pe3v )
+   SUBROUTINE dyn_atf( kt, Kbb, Kmm, Kaa, puu, pvv, pe3t, pe3u, pe3v )
       INTEGER                             , INTENT(in   ) :: kt               ! ocean time-step index
       INTEGER                             , INTENT(in   ) :: Kbb, Kmm, Kaa    ! before and after time level indices
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynatf_qco.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynatf_qco.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynatf_qco.F90	(revision 14200)
@@ -66,5 +66,5 @@
 CONTAINS
 
-   SUBROUTINE dyn_atf_qco ( kt, Kbb, Kmm, Kaa, puu, pvv )
+   SUBROUTINE dyn_atf_qco( kt, Kbb, Kmm, Kaa, puu, pvv )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE dyn_atf_qco  ***
@@ -196,5 +196,21 @@
       ! JC: Would be more clever to swap variables than to make a full vertical
       ! integration
-      ! CAUTION : calculation need to be done in the same way than see GM  
+      ! CAUTION : calculation need to be done in the same way than see GM
+#if defined key_linssh
+      uu_b(:,:,Kaa) = e3u(:,:,1,Kaa) * puu(:,:,1,Kaa) * umask(:,:,1)
+      uu_b(:,:,Kmm) = e3u(:,:,1,Kmm) * puu(:,:,1,Kmm) * umask(:,:,1)
+      vv_b(:,:,Kaa) = e3v(:,:,1,Kaa) * pvv(:,:,1,Kaa) * vmask(:,:,1)
+      vv_b(:,:,Kmm) = e3v(:,:,1,Kmm) * pvv(:,:,1,Kmm) * vmask(:,:,1)
+      DO jk = 2, jpkm1
+         uu_b(:,:,Kaa) = uu_b(:,:,Kaa) + e3u(:,:,jk,Kaa) * puu(:,:,jk,Kaa) * umask(:,:,jk)
+         uu_b(:,:,Kmm) = uu_b(:,:,Kmm) + e3u(:,:,jk,Kmm) * puu(:,:,jk,Kmm) * umask(:,:,jk)
+         vv_b(:,:,Kaa) = vv_b(:,:,Kaa) + e3v(:,:,jk,Kaa) * pvv(:,:,jk,Kaa) * vmask(:,:,jk)
+         vv_b(:,:,Kmm) = vv_b(:,:,Kmm) + e3v(:,:,jk,Kmm) * pvv(:,:,jk,Kmm) * vmask(:,:,jk)
+      END DO
+      uu_b(:,:,Kaa) = uu_b(:,:,Kaa) * r1_hu(:,:,Kaa)
+      vv_b(:,:,Kaa) = vv_b(:,:,Kaa) * r1_hv(:,:,Kaa)
+      uu_b(:,:,Kmm) = uu_b(:,:,Kmm) * r1_hu(:,:,Kmm)
+      vv_b(:,:,Kmm) = vv_b(:,:,Kmm) * r1_hv(:,:,Kmm)
+#else
       uu_b(:,:,Kaa) = e3u(:,:,1,Kaa) * puu(:,:,1,Kaa) * umask(:,:,1)
       uu_b(:,:,Kmm) = (e3u_0(:,:,1) * ( 1._wp + r3u_f(:,:) * umask(:,:,1) )) * puu(:,:,1,Kmm) * umask(:,:,1)
@@ -211,4 +227,5 @@
       uu_b(:,:,Kmm) = uu_b(:,:,Kmm) * (r1_hu_0(:,:)/( 1._wp + r3u_f(:,:) ))
       vv_b(:,:,Kmm) = vv_b(:,:,Kmm) * (r1_hv_0(:,:)/( 1._wp + r3v_f(:,:) ))
+#endif
       !
       IF( .NOT.ln_dynspg_ts ) THEN        ! output the barotropic currents
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynhpg.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynhpg.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynhpg.F90	(revision 14200)
@@ -183,14 +183,15 @@
       ENDIF
       !
-      IF( .NOT.ln_linssh .AND. .NOT.(ln_hpg_sco.OR.ln_hpg_prj.OR.ln_hpg_isf.OR.ln_hpg_djc) )          &
-         &   CALL ctl_stop('dyn_hpg_init : non-linear free surface requires either ',   &
-         &                 '   the standard jacobian formulation hpg_sco    or '    ,   &
-         &                 '   the pressure jacobian formulation hpg_prj'             )
-         !
+      IF( .NOT.ln_linssh .AND. (ln_hpg_zco.OR.ln_hpg_zps) )   &
+         &   CALL ctl_stop( 'dyn_hpg_init : non-linear free surface incompatible with hpg_zco or hpg_zps' )
+      !
+      IF( (.NOT.ln_hpg_isf .AND. ln_isfcav) .OR. (ln_hpg_isf .AND. .NOT.ln_isfcav) )                  &
+         &   CALL ctl_stop( 'dyn_hpg_init : ln_hpg_isf=T requires ln_isfcav=T and vice versa' )  
+      !
+#if defined key_qco
       IF( ln_hpg_isf ) THEN
-         IF( .NOT. ln_isfcav )   CALL ctl_stop( ' hpg_isf not available if ln_isfcav = false ' )
-       ELSE
-         IF(       ln_isfcav )   CALL ctl_stop( 'Only hpg_isf has been corrected to work with ice shelf cavity.' )
+         CALL ctl_stop( 'dyn_hpg_init : key_qco and ln_hpg_isf not yet compatible' )
       ENDIF
+#endif
       !
       !                               ! Set nhpg from ln_hpg_... flags & consistency check
@@ -239,4 +240,5 @@
          END IF
       END IF
+      !
    END SUBROUTINE dyn_hpg_init
 
@@ -756,5 +758,5 @@
       ! 4. a) Upper half of top-most grid box, compute and store
       !-------------------------------------------------------------
-! *** AY note: ssh(ji,jj,Kmm) + gde3w(ji,jj,1) = e3w(ji,jj,1)
+! *** AY note: ssh(ji,jj,Kmm) + gde3w(ji,jj,1) = e3w(ji,jj,1,Kmm)
       DO_2D( 0, 1, 0, 1)
          z_rho_k(ji,jj,1) =  grav * ( ssh(ji,jj,Kmm) + gde3w(ji,jj,1) )                        & 
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynvor.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynvor.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/dynvor.F90	(revision 14200)
@@ -406,5 +406,5 @@
          END SELECT
          !
-#if defined key_qco
+#if defined key_qco   ||   defined key_linssh
          DO_2D( 1, 0, 1, 0 )                 !==  potential vorticity  ==!   (key_qco)
             zwz(ji,jj) = zwz(ji,jj) / e3f_vor(ji,jj,jk)
@@ -533,5 +533,5 @@
          !
          !
-#if defined key_qco
+#if defined key_qco   ||   defined key_linssh
          DO_2D( 1, 0, 1, 0 )                 !==  potential vorticity  ==!   (key_qco)
             zwz(ji,jj) = zwz(ji,jj) / e3f_vor(ji,jj,jk)
@@ -624,5 +624,5 @@
          !                                             ! ===============
          !
-#if defined key_qco
+#if defined key_qco   ||   defined key_linssh
          DO_2D( 1, 0, 1, 0 )                 ! == reciprocal of e3 at F-point (key_qco)
             z1_e3f(ji,jj) = 1._wp / e3f_vor(ji,jj,jk)
@@ -952,6 +952,6 @@
          !
       END SELECT
-#if defined key_qco
-      SELECT CASE( nvor_scheme )    ! qco case: pre-computed a specific e3f_0 for some vorticity schemes
+#if defined key_qco   ||   defined key_linssh
+      SELECT CASE( nvor_scheme )    ! qco or linssh cases : pre-computed a specific e3f_0 for some vorticity schemes
       CASE( np_ENS , np_ENE , np_EEN , np_MIX )
          !
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/sshwzv.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/sshwzv.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DYN/sshwzv.F90	(revision 14200)
@@ -18,5 +18,4 @@
    !!   ssh_atf       : time filter the ssh arrays
    !!   wzv           : compute now vertical velocity
-   !!   ssh_init_rst  : ssh set from restart or domcfg.nc file or usr_def_istat_ssh
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and tracers variables
@@ -29,4 +28,5 @@
    USE bdy_oce , ONLY : ln_bdy, bdytmask   ! Open BounDarY
    USE bdydyn2d       ! bdy_ssh routine
+   USE wet_dry        ! Wetting/Drying flux limiting
 #if defined key_agrif
    USE agrif_oce
@@ -41,6 +41,4 @@
    USE lib_mpp        ! MPP library
    USE timing         ! Timing
-   USE wet_dry        ! Wetting/Drying flux limiting
-   USE usrdef_istate, ONLY : usr_def_istate_ssh   ! user defined ssh initial state 
    
    IMPLICIT NONE
@@ -51,5 +49,4 @@
    PUBLIC   wAimp          ! called by step.F90
    PUBLIC   ssh_atf        ! called by step.F90
-   PUBLIC   ssh_init_rst   ! called by domain.F90
 
    !! * Substitutions
@@ -436,86 +433,4 @@
       !
    END SUBROUTINE wAimp
-
-
-   SUBROUTINE ssh_init_rst( Kbb, Kmm, Kaa )
-      !!---------------------------------------------------------------------
-      !!                   ***  ROUTINE ssh_init_rst  ***
-      !!
-      !! ** Purpose :   ssh initialization of the sea surface height (ssh)
-      !!
-      !! ** Method  :   set ssh from restart or read configuration, or user_def
-      !!              * ln_rstart = T
-      !!                   USE of IOM library to read ssh in the restart file
-      !!                   Leap-Frog: Kbb and Kmm are read except for l_1st_euler=T
-      !!
-      !!              * otherwise 
-      !!                   call user defined ssh or
-      !!                   set to -ssh_ref in wet and drying case with domcfg.nc
-      !!
-      !!              NB: ssh_b/n are written by restart.F90
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   Kbb, Kmm, Kaa   ! ocean time level indices
-      !
-      INTEGER ::   ji, jj, jk
-      !!----------------------------------------------------------------------
-      !
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) 'ssh_init_rst : ssh initialization'
-         WRITE(numout,*) '~~~~~~~~~~~~ '
-      ENDIF
-      !
-      !                            !=============================!
-      IF( ln_rstart ) THEN         !==  Read the restart file  ==!
-         !                         !=============================!
-         !
-         !                                     !*  Read ssh at Kmm
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*)    '      Kmm sea surface height read in the restart file'
-         CALL iom_get( numror, jpdom_auto, 'sshn'   , ssh(:,:,Kmm) )
-         !
-         IF( l_1st_euler ) THEN                !* Euler at first time-step
-            IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) '      Euler first time step : ssh(Kbb) = ssh(Kmm)'
-            ssh(:,:,Kbb) = ssh(:,:,Kmm)
-            !
-         ELSE                                  !* read ssh at Kbb
-            IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) '      Kbb sea surface height read in the restart file'
-            CALL iom_get( numror, jpdom_auto, 'sshb', ssh(:,:,Kbb) )
-         ENDIF
-         !                         !============================!
-      ELSE                         !==  Initialize at "rest"  ==!
-         !                         !============================!
-         !
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*)    '      initialization at rest'
-         !
-         IF( ll_wd ) THEN                      !* wet and dry 
-            !
-            IF( ln_read_cfg  ) THEN                 ! read configuration : ssh_ref is read in domain_cfg file
-!!st  why ssh is not masked : i.e. ssh(:,:,Kmm) = -ssh_ref*ssmask(:,:),
-!!st  since at the 1st time step lbclnk will be applied on ssh at Kaa but not initially at Kbb and Kmm
-               ssh(:,:,Kbb) = -ssh_ref
-               !
-               DO_2D( 1, 1, 1, 1 )
-                  IF( ht_0(ji,jj)-ssh_ref <  rn_wdmin1 ) THEN   ! if total depth is less than min depth
-                     ssh(ji,jj,Kbb) = rn_wdmin1 - ht_0(ji,jj)
-                  ENDIF
-               END_2D
-            ELSE                                    ! user define configuration case  
-               CALL usr_def_istate_ssh( tmask, ssh(:,:,Kbb) )
-            ENDIF
-            !
-         ELSE                                  !* user defined configuration
-            CALL usr_def_istate_ssh( tmask, ssh(:,:,Kbb) )
-            !
-         ENDIF
-         !
-         ssh(:,:,Kmm) = ssh(:,:,Kbb)           !* set now values from to before ones
-         ssh(:,:,Kaa) = 0._wp 
-      ENDIF
-      !
-   END SUBROUTINE ssh_init_rst
       
    !!======================================================================
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ICB/icbutl.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ICB/icbutl.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ICB/icbutl.F90	(revision 14200)
@@ -57,4 +57,6 @@
    PUBLIC   icb_utl_heat          ! routine called in icbdia module
 
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
@@ -127,7 +129,8 @@
             CALL lbc_lnk_icb( 'icbutl', ztmp, 'V', -1._wp, 1, 1 )
             voce_e(:,:,jk) = ztmp(:,:)
+            !
+            e3t_e(1:jpi,1:jpj,jk) = e3t(:,:,jk,Kmm)
          END DO
-         toce_e(1:jpi,1:jpj,1:jpk) = ts(:,:,:,1,Kmm)
-         e3t_e (1:jpi,1:jpj,1:jpk) = e3t(:,:,:,Kmm)
+         toce_e(1:jpi,1:jpj,:) = ts(:,:,:,1,Kmm)
       END IF
       !
